
package de.ivu.elect.business.stimmzettel.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum;

@RequestScoped
@Named(StimmzettelKopfdatumConversationSelect.COMPONENT_NAME)
public class StimmzettelKopfdatumConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmzettelKopfdatumConversationSelect";

  @Inject
  protected transient StimmzettelKopfdatumExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(StimmzettelKopfdatumConversationStore.class)
  protected transient StimmzettelKopfdatumConversationStore conversationStore;

  public StimmzettelKopfdatumConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public StimmzettelKopfdatum getEntity() {
    return getEntityInternal();
  }

  private StimmzettelKopfdatum getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(StimmzettelKopfdatum entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(StimmzettelKopfdatum entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected StimmzettelKopfdatum attach(StimmzettelKopfdatum entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected StimmzettelKopfdatum attach( de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
